Index: trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuPrint.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuPrint.asm	(revision 95)
+++ trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuPrint.asm	(revision 96)
@@ -19,12 +19,12 @@
 BootMenuPrint_TitleStrings:
 	mov		si, ROMVARS.szTitle
-	call	PrintNullTerminatedStringFromCSSIandSetCF
-	call	BootMenuPrint_Newline
+	call	BootMenuPrint_NullTerminatedStringFromCSSIandSetCF
+	CALL_DISPLAY_LIBRARY PrintNewlineCharacters
 	mov		si, ROMVARS.szVersion
-	jmp		PrintNullTerminatedStringFromCSSIandSetCF
-
-
-;--------------------------------------------------------------------
-; BootMenuPrint_Newline
+	jmp		BootMenuPrint_NullTerminatedStringFromCSSIandSetCF
+
+
+;--------------------------------------------------------------------
+; BootMenuPrint_ClearScreen
 ;	Parameters:
 ;		Nothing
@@ -35,52 +35,7 @@
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-BootMenuPrint_Newline:
-	CALL_DISPLAY_LIBRARY PrintNewlineCharacters
-	ret
-
-
-;--------------------------------------------------------------------
-; BootMenuPrint_ClearScreen
-;	Parameters:
-;		Nothing
-;	Returns:
-;		Nothing
-;	Corrupts registers:
-;		AX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
 BootMenuPrint_ClearScreen:
-	push	di
 	mov		ax, ' ' | (MONO_NORMAL<<8)
 	CALL_DISPLAY_LIBRARY ClearScreenWithCharInALandAttrInAH
-	pop		di
-	ret
-
-
-;--------------------------------------------------------------------
-; Translates and prints drive number.
-;
-; BootMenuPrint_TranslatedDriveNumber
-;	Parameters:
-;		DL:		Untranslated drive number
-;		DS:		RAMVARS segment
-;	Returns:
-;		Nothing
-;	Corrupts registers:
-;		AX, DI
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-BootMenuPrint_TranslatedDriveNumber:
-	push	dx
-	push	bx
-
-	call	DriveXlate_ToOrBack
-	eMOVZX	ax, dl		; Drive number to AL
-	CALL_DISPLAY_LIBRARY PrintWordFromAXwithBaseInBX
-	mov		al, ' '		; Print space
-	CALL_DISPLAY_LIBRARY PrintCharacterFromAL
-
-	pop		bx
-	pop		dx
 	ret
 
@@ -155,5 +110,5 @@
 .HardDiskMenuitemForForeignDrive:
 	mov		si, g_szforeignHD
-	jmp		PrintNullTerminatedStringFromCSSIandSetCF
+	jmp		BootMenuPrint_NullTerminatedStringFromCSSIandSetCF
 
 
@@ -365,5 +320,5 @@
 
 ;--------------------------------------------------------------------
-; PrintNullTerminatedStringFromCSSIandSetCF
+; BootMenuPrint_NullTerminatedStringFromCSSIandSetCF
 ;	Parameters:
 ;		CS:SI:	Ptr to NULL terminated string to print
@@ -374,5 +329,5 @@
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-PrintNullTerminatedStringFromCSSIandSetCF:
+BootMenuPrint_NullTerminatedStringFromCSSIandSetCF:
 	CALL_DISPLAY_LIBRARY PrintNullTerminatedStringFromCSSI
 	stc
Index: trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuPrintCfg.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuPrintCfg.asm	(revision 95)
+++ trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuPrintCfg.asm	(revision 96)
@@ -20,56 +20,12 @@
 ALIGN JUMP_ALIGN
 BootMenuPrintCfg_ForOurDrive:
-	call	BootMenuPrintCfg_HeaderAndChangeLine
+	mov		si, g_szCfgHeader
+	call	BootMenuPrint_NullTerminatedStringFromCSSIandSetCF
 	call	BootMenuPrintCfg_GetPointers
-	call	BootMenuPrintCfg_PushAndFormatCfgString
-	jmp		BootMenuPrint_Newline
+	; Fall to PushAndFormatCfgString
 
 
 ;--------------------------------------------------------------------
-; Prints configuration header and changes for printing values.
-;
-; BootMenuPrintCfg_HeaderAndChangeLine
-;	Parameters:
-;		Nothing
-;	Returns:
-;		Nothing
-;	Corrupts registers:
-;		AX, SI, DI
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-BootMenuPrintCfg_HeaderAndChangeLine:
-	mov		si, g_szCfgHeader
-	call	PrintNullTerminatedStringFromCSSIandSetCF
-	jmp		BootMenuPrint_Newline
-
-
-;--------------------------------------------------------------------
-; Return all necessary pointers to drive information structs.
-;
-; BootMenuPrintCfg_GetPointers
-;	Parameters:
-;		DS:DI:	Ptr to DPT
-;	Returns:
-;		DS:DI:	Ptr to DPT
-;		ES:BX:	Ptr to BOOTNFO
-;		CS:SI:	Ptr to IDEVARS
-;	Corrupts registers:
-;		AX, DL
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-BootMenuPrintCfg_GetPointers:
-	mov		dl, [di+DPT.bDrvNum]		; Load Drive number to DL
-	call	BootInfo_GetOffsetToBX		; ES:BX now points...
-	LOAD_BDA_SEGMENT_TO	es, ax			; ...to BOOTNFO
-	mov		al, [di+DPT.bIdeOff]
-	xchg	si, ax						; CS:SI now points to IDEVARS
-	ret
-
-
-;--------------------------------------------------------------------
-; Pushes all string formatting parameters and prints
-; formatted configuration string.
-;
-; BootMenuPrintCfg_PushAndFormatCfgString
+; PushAndFormatCfgString
 ;	Parameters:
 ;		DS:DI:	Ptr to DPT
@@ -82,7 +38,6 @@
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-BootMenuPrintCfg_PushAndFormatCfgString:
+PushAndFormatCfgString:
 	push	bp
-
 	mov		bp, sp
 	; Fall to first push below
@@ -97,12 +52,12 @@
 ;		Nothing (jumps to next push below)
 ;	Corrupts registers:
-;		AX, DX
+;		AX
 ;--------------------------------------------------------------------
 PushAddressingMode:
-	mov		dx, bx				; Backup BX to DX
+	xchg	ax, bx
 	mov		bx, MASK_DPT_ADDR	; Load addressing mode mask
 	and		bl, [di+DPT.bFlags]	; Addressing mode now in BX
 	push	WORD [cs:bx+.rgszAddressingModeString]
-	mov		bx, dx
+	xchg	bx, ax
 	jmp		SHORT .NextPush
 ALIGN WORD_ALIGN
@@ -208,7 +163,5 @@
 
 ;--------------------------------------------------------------------
-; Prints formatted configuration string from parameters pushed to stack.
-;
-; BootMenuPrintCfg_ValuesFromStack
+; PrintValuesFromStack
 ;	Parameters:
 ;		Stack:	All formatting parameters
@@ -218,5 +171,26 @@
 ;		AX, SI, DI
 ;--------------------------------------------------------------------
-BootMenuPrintCfg_ValuesFromStack:
+PrintValuesFromStack:
 	mov		si, g_szCfgFormat
-	jmp		PrintNullTerminatedStringFromCSSIandSetCF
+	jmp		BootMenuPrint_NullTerminatedStringFromCSSIandSetCF
+
+
+;--------------------------------------------------------------------
+; BootMenuPrintCfg_GetPointers
+;	Parameters:
+;		DS:DI:	Ptr to DPT
+;	Returns:
+;		DS:DI:	Ptr to DPT
+;		ES:BX:	Ptr to BOOTNFO
+;		CS:SI:	Ptr to IDEVARS
+;	Corrupts registers:
+;		AX, DL
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+BootMenuPrintCfg_GetPointers:
+	mov		dl, [di+DPT.bDrvNum]		; Load Drive number to DL
+	call	BootInfo_GetOffsetToBX		; ES:BX now points...
+	LOAD_BDA_SEGMENT_TO	es, ax			; ...to BOOTNFO
+	mov		al, [di+DPT.bIdeOff]
+	xchg	si, ax						; CS:SI now points to IDEVARS
+	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Boot/BootSector.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Boot/BootSector.asm	(revision 96)
+++ trunk/XTIDE_Universal_BIOS/Src/Boot/BootSector.asm	(revision 96)
@@ -0,0 +1,110 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	Reading and jumping to boot sector.
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; BootSector_TryToLoadFromDriveDL
+;	Parameters:
+;		DL:		Drive to boot from (translated, 00h or 80h)
+;		DS:		RAMVARS segment
+;	Returns:
+;		ES:BX:	Ptr to boot sector (if successfull)
+;		CF:		Set if boot sector loaded succesfully
+;				Cleared if failed to load boot sector
+;	Corrupts registers:
+;		AX, CX, DH, DI, (DL if failed to read boot sector)
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+BootSector_TryToLoadFromDriveDL:
+	call	BootPrint_TryToBootFromDL
+	call	LoadFirstSectorFromDriveDL
+	jc		SHORT .FailedToLoadFirstSector
+
+	test	dl, 80h
+	jz		SHORT .AlwaysBootFromFloppyDriveForBooterGames
+	cmp		WORD [es:bx+510], 0AA55h		; Valid boot sector?
+	jne		SHORT .FirstHardDiskSectorNotBootable
+.AlwaysBootFromFloppyDriveForBooterGames:
+	mov		bx, g_szFound
+	call	BootPrint_BootSectorResultStringFromBX
+	stc
+	ret
+.FailedToLoadFirstSector:
+	call	BootPrint_FailedToLoadFirstSector
+	clc
+	ret
+.FirstHardDiskSectorNotBootable:
+	mov		bx, g_szNotFound
+	call	BootPrint_BootSectorResultStringFromBX
+	clc
+	ret
+
+;--------------------------------------------------------------------
+; LoadFirstSectorFromDriveDL
+;	Parameters:
+;		DL:		Drive to boot from (translated, 00h or 80h)
+;	Returns:
+;		AH:		INT 13h error code
+;		ES:BX:	Ptr to boot sector (if successfull)
+;		CF:		Cleared if read successfull
+;				Set if any error
+;	Corrupts registers:
+;		AL, CX, DH, DI
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+LoadFirstSectorFromDriveDL:
+	LOAD_BDA_SEGMENT_TO	es, bx				; ES:BX now points to...
+	mov		bx, BOOTVARS.rgbBootSect		; ...boot sector location
+	mov		di, BOOT_READ_RETRY_TIMES		; Initialize retry counter
+ALIGN JUMP_ALIGN
+.ReadRetryLoop:
+	call	.ResetBootDriveFromDL
+	call	.LoadFirstSectorFromDLtoESBX
+	jnc		SHORT .Return
+	dec		di								; Decrement retry counter
+	jnz		SHORT .ReadRetryLoop			; Loop while retries left
+ALIGN JUMP_ALIGN
+.Return:
+	ret
+
+;--------------------------------------------------------------------
+; .ResetBootDriveFromDL
+;	Parameters:
+;		DL:		Drive to boot from (translated, 00h or 80h)
+;	Returns:
+;		AH:		INT 13h error code
+;		CF:		Cleared if read successfull
+;				Set if any error
+;	Corrupts registers:
+;		AL
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+.ResetBootDriveFromDL:
+	xor		ax, ax							; AH=0h, Disk Controller Reset
+	test	dl, 80h							; Floppy drive?
+	eCMOVNZ	ah, 0Dh							; AH=Dh, Reset Hard Disk (Alternate reset)
+	int		INTV_DISK_FUNC
+	ret
+
+;--------------------------------------------------------------------
+; .LoadFirstSectorFromDLtoESBX
+;	Parameters:
+;		DL:		Drive to boot from (translated, 00h or 80h)
+;		ES:BX:	Destination buffer for boot sector
+;	Returns:
+;		AH:		INT 13h error code
+;		ES:BX:	Ptr to boot sector
+;		CF:		Cleared if read successfull
+;				Set if any error
+;	Corrupts registers:
+;		AL, CX, DH
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+.LoadFirstSectorFromDLtoESBX:
+	mov		ax, 0201h						; Read 1 sector
+	mov		cx, 1							; Cylinder 0, Sector 1
+	xor		dh, dh							; Head 0
+	int		INTV_DISK_FUNC
+	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Boot/BootVars.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Boot/BootVars.asm	(revision 95)
+++ trunk/XTIDE_Universal_BIOS/Src/Boot/BootVars.asm	(revision 96)
@@ -62,6 +62,4 @@
 	cli									; Disable interrupts
 	LOAD_BDA_SEGMENT_TO	ss, sp
-;	eLSS	sp, ss:BOOTVARS.dwPostStack	; Expanded macro to remove
-										; unneeded CLI instruction
 %ifndef USE_386
 	mov		sp, [ss:BOOTVARS.dwPostStack]
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int19h.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int19h.asm	(revision 95)
+++ 	(revision )
@@ -1,154 +1,0 @@
-; Project name	:	XTIDE Universal BIOS
-; Description	:	Int 19h BIOS functions (Boot Strap Loader).
-
-; Section containing code
-SECTION .text
-
-B_READ_RETRY_TIMES	EQU	3	; Number of times to retry
-
-
-;--------------------------------------------------------------------
-; Boots if boot sector is successfully read from the drive.
-;
-; Int19h_TryToLoadBootSectorFromDL
-;	Parameters:
-;		DL:		Drive to boot from (translated, 00h or 80h)
-;		DS:		RAMVARS segment
-;	Returns:
-;		ES:BX:	Ptr to boot sector (if successfull)
-;		CF:		Set if boot sector loaded succesfully
-;				Cleared if failed to load boot sector
-;	Corrupts registers:
-;		AX, CX, DH, DI, (DL if failed to read boot sector)
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-Int19h_TryToLoadBootSectorFromDL:
-	call	BootPrint_TryToBootFromDL
-	call	LoadFirstSectorFromDriveDL
-	jc		SHORT .FailedToLoadFirstSector
-
-	test	dl, 80h
-	jz		SHORT .AlwaysBootFromFloppyDriveForBooterGames
-	cmp		WORD [es:bx+510], 0AA55h		; Valid boot sector?
-	jne		SHORT .FirstHardDiskSectorNotBootable
-.AlwaysBootFromFloppyDriveForBooterGames:
-	mov		bx, g_szFound
-	call	BootPrint_BootSectorResultStringFromBX
-	stc
-	ret
-.FailedToLoadFirstSector:
-	call	BootPrint_FailedToLoadFirstSector
-	clc
-	ret
-.FirstHardDiskSectorNotBootable:
-	mov		bx, g_szNotFound
-	call	BootPrint_BootSectorResultStringFromBX
-	clc
-	ret
-
-;--------------------------------------------------------------------
-; LoadFirstSectorFromDriveDL
-;	Parameters:
-;		DL:		Drive to boot from (translated, 00h or 80h)
-;	Returns:
-;		AH:		INT 13h error code
-;		ES:BX:	Ptr to boot sector (if successfull)
-;		CF:		Cleared if read successfull
-;				Set if any error
-;	Corrupts registers:
-;		AL, CX, DH, DI
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-LoadFirstSectorFromDriveDL:
-	LOAD_BDA_SEGMENT_TO	es, bx				; ES:BX now points to...
-	mov		bx, BOOTVARS.rgbBootSect		; ...boot sector location
-	mov		di, B_READ_RETRY_TIMES			; Initialize retry counter
-ALIGN JUMP_ALIGN
-.ReadRetryLoop:
-	call	.ResetBootDriveFromDL
-	call	.LoadFirstSectorFromDLtoESBX
-	jnc		SHORT .Return
-	dec		di								; Decrement retry counter
-	jnz		SHORT .ReadRetryLoop			; Loop while retries left
-ALIGN JUMP_ALIGN
-.Return:
-	ret
-
-;--------------------------------------------------------------------
-; .ResetBootDriveFromDL
-;	Parameters:
-;		DL:		Drive to boot from (translated, 00h or 80h)
-;	Returns:
-;		AH:		INT 13h error code
-;		CF:		Cleared if read successfull
-;				Set if any error
-;	Corrupts registers:
-;		AL
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-.ResetBootDriveFromDL:
-	xor		ax, ax							; AH=0h, Disk Controller Reset
-	test	dl, 80h							; Floppy drive?
-	eCMOVNZ	ah, 0Dh							; AH=Dh, Reset Hard Disk (Alternate reset)
-	int		INTV_DISK_FUNC
-	ret
-
-;--------------------------------------------------------------------
-; Reads first sector (boot sector) from drive DL to ES:BX.
-;
-; .LoadFirstSectorFromDLtoESBX
-;	Parameters:
-;		DL:		Drive to boot from (translated, 00h or 80h)
-;		ES:BX:	Destination buffer for boot sector
-;	Returns:
-;		AH:		INT 13h error code
-;		ES:BX:	Ptr to boot sector
-;		CF:		Cleared if read successfull
-;				Set if any error
-;	Corrupts registers:
-;		AL, CX, DH
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-.LoadFirstSectorFromDLtoESBX:
-	mov		ax, 0201h						; Read 1 sector
-	mov		cx, 1							; Cylinder 0, Sector 1
-	xor		dh, dh							; Head 0
-	int		INTV_DISK_FUNC
-	ret
-
-
-;--------------------------------------------------------------------
-; Jumps to boot sector pointed by ES:BX.
-;
-; Int19h_JumpToBootSector
-;	Parameters:
-;		DL:		Drive to boot from (translated, 00h or 80h)
-;		ES:BX:	Ptr to boot sector
-;	Returns:
-;		Never returns
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-Int19h_JumpToBootSector:
-	push	es								; Push boot sector segment
-	push	bx								; Push boot sector offset
-	call	Int19h_ClearSegmentsForBoot
-	xor		dh, dh							; Device supported by INT 13h
-	retf
-
-;--------------------------------------------------------------------
-; Clears DS and ES registers to zero.
-;
-; Int19h_ClearSegmentsForBoot
-;	Parameters:
-;		Nothing
-;	Returns:
-;		DS=ES:	Zero
-;	Corrupts registers:
-;		AX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-Int19h_ClearSegmentsForBoot:
-	xor		ax, ax
-	mov		ds, ax
-	mov		es, ax
-	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int19hMenu.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int19hMenu.asm	(revision 95)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int19hMenu.asm	(revision 96)
@@ -22,12 +22,10 @@
 
 	; Install new INT 19h handler now that BOOTVARS has been initialized
-	mov		WORD [INTV_BOOTSTRAP*4], Int19hMenu_Display
+	mov		WORD [INTV_BOOTSTRAP*4], DisplayBootMenu
 	mov		WORD [INTV_BOOTSTRAP*4+2], cs
-	; Fall to Int19hMenu_Display
+	; Fall to DisplayBootMenu
 
 ;--------------------------------------------------------------------
-; Displays Boot Menu so user can select drive to boot from.
-;
-; Int19hMenu_Display
+; DisplayBootMenu
 ;	Parameters:
 ;		Nothing
@@ -36,14 +34,11 @@
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-Int19hMenu_Display:
-	sti									; Enable interrupts
+DisplayBootMenu:
 	call	BootVars_SwitchToBootMenuStack
 	call	RamVars_GetSegmentToDS
-	; Fall to Int19hMenu_ProcessMenuSelectionsUntilBootable
+	; Fall to .ProcessMenuSelectionsUntilBootable
 
 ;--------------------------------------------------------------------
-; Processes user menu selections until bootable drive is selected.
-;
-; Int19hMenu_ProcessMenuSelectionsUntilBootable
+; .ProcessMenuSelectionsUntilBootable
 ;	Parameters:
 ;		DS:		RAMVARS segment
@@ -52,11 +47,27 @@
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-Int19hMenu_ProcessMenuSelectionsUntilBootable:
+.ProcessMenuSelectionsUntilBootable:
 	call	BootMenu_DisplayAndReturnSelection
 	call	DriveXlate_ToOrBack			; Translate drive number
-	call	Int19h_TryToLoadBootSectorFromDL
-	jnc		SHORT Int19hMenu_ProcessMenuSelectionsUntilBootable	; Boot failure, show menu again
+	call	BootSector_TryToLoadFromDriveDL
+	jnc		SHORT .ProcessMenuSelectionsUntilBootable	; Boot failure, show menu again
 	call	BootVars_SwitchBackToPostStack
-	jmp		Int19h_JumpToBootSector
+	; Fall to JumpToBootSector
+
+;--------------------------------------------------------------------
+; JumpToBootSector
+;	Parameters:
+;		DL:		Drive to boot from (translated, 00h or 80h)
+;		ES:BX:	Ptr to boot sector
+;	Returns:
+;		Never returns
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+JumpToBootSector:
+	push	es								; Push boot sector segment
+	push	bx								; Push boot sector offset
+	call	ClearSegmentsForBoot
+	xor		dh, dh							; Device supported by INT 13h
+	retf
 
 
@@ -71,4 +82,21 @@
 Int19hMenu_RomBoot:
 	call	BootVars_SwitchBackToPostStack
-	call	Int19h_ClearSegmentsForBoot
+	call	ClearSegmentsForBoot
 	int		INTV_BOOT_FAILURE		; Never returns
+
+
+;--------------------------------------------------------------------
+; ClearSegmentsForBoot
+;	Parameters:
+;		Nothing
+;	Returns:
+;		DS=ES:	Zero
+;	Corrupts registers:
+;		AX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+ClearSegmentsForBoot:
+	xor		ax, ax
+	mov		ds, ax
+	mov		es, ax
+	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectPrint.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectPrint.asm	(revision 95)
+++ trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectPrint.asm	(revision 96)
@@ -104,5 +104,5 @@
 .PrintDriveNotFound:
 	mov		si, g_szNotFound
-	call	PrintNullTerminatedStringFromCSSIandSetCF
+	call	BootMenuPrint_NullTerminatedStringFromCSSIandSetCF
 	pop		di
 	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Main.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Main.asm	(revision 95)
+++ trunk/XTIDE_Universal_BIOS/Src/Main.asm	(revision 96)
@@ -124,4 +124,6 @@
 %include "BootMenuEvent.asm"	; For menu library event handling
 %include "FloppyDrive.asm"		; Floppy Drive related functions
+%include "BootSector.asm"		; For loading boot sector
+%include "BootPrint.asm"		; For printing boot information
 %include "BootMenuPrint.asm"	; For printing Boot Menu strings
 %include "BootMenuPrintCfg.asm"	; For printing hard disk configuration
@@ -140,10 +142,8 @@
 ; Include .asm files (Interrupt handlers)
 %include "Int13h.asm"			; For Int 13h, Disk functions
-%include "Int19h.asm"			; For Int 19h, Boot Loader
 %ifndef USE_AT
 	%include "Int19hLate.asm"	; For late initialization
 %endif
 %include "Int19hMenu.asm"		; For Int 19h, Boot Loader for Boot Menu
-%include "BootPrint.asm"		; For printing boot information
 
 ; Include .asm files (Hard Disk BIOS functions)
Index: trunk/XTIDE_Universal_BIOS/Src/Strings.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Strings.asm	(revision 95)
+++ trunk/XTIDE_Universal_BIOS/Src/Strings.asm	(revision 96)
@@ -35,5 +35,5 @@
 g_szSizeSingle:	db	"%s%u.%u %ciB",NULL
 g_szSizeDual:	db	"%s%u.%u %ciB / %u.%u %ciB",NULL
-g_szCfgHeader:	db	"Addr.",SINGLE_VERTICAL,"Block",SINGLE_VERTICAL,"Bus",  SINGLE_VERTICAL,"IRQ",  SINGLE_VERTICAL,"Reset",NULL
+g_szCfgHeader:	db	"Addr.",SINGLE_VERTICAL,"Block",SINGLE_VERTICAL,"Bus",  SINGLE_VERTICAL,"IRQ",  SINGLE_VERTICAL,"Reset",CR,LF,NULL
 g_szCfgFormat:	db	"%s"   ,SINGLE_VERTICAL,"%5u",  SINGLE_VERTICAL,"%c%2u",SINGLE_VERTICAL," %c%c",SINGLE_VERTICAL,"%5x",  NULL
 g_szLCHS:		db	"L-CHS",NULL